﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Runtime.InteropServices;

namespace SWECD1200
{
    unsafe public partial class Principal : Form
    {
        /// <summary>
        /// Estrutura do Ip e da Porta.
        /// </summary>
        [StructLayout(LayoutKind.Sequential, CharSet = CharSet.Ansi)]
        public struct stAddress
        {
            /// <summary>
            /// Endereço de Ip
            /// </summary>
            [MarshalAs(UnmanagedType.U4 )] public UInt32 Ip;
            /// <summary>
            /// Porta do Ip.
            /// </summary>
            [MarshalAs(UnmanagedType.U2 )] public UInt16 Port;
        }


        #region Declaração das funções da DLL ecdSweda.dll
        /// <summary>
        /// //Inicia o servidor dos Terminais de Consulta
        /// </summary>
        /// <param name="HWND"></param>
        /// <returns></returns>        
        [DllImport("ecdSweda.dll", CallingConvention = CallingConvention.StdCall)]
        public static extern bool bInitialize(IntPtr HWND);
        //[DllImport("ecdSweda.dll")]
        //public static extern bool bInitialize(IntPtr HWND);

        /// <summary>
        /// //Finaliza o servidor dos Terminais de Consulta
        /// </summary>
        /// <returns></returns>
        [DllImport("ecdSweda.dll", CallingConvention = CallingConvention.StdCall)] public static extern unsafe bool bTerminate();
        
        /// <summary>
        /// Retorna o identificador da mensagen do Windows referente ao recebimento de dados dos TCDs
        /// </summary>
        /// <param name="MsgWinReg"></param>
        [DllImport("ecdSweda.dll", CallingConvention = CallingConvention.StdCall)] public static extern unsafe void vGetMsgWinReceiveDataTC(ref uint MsgWinReg);
        
        /// <summary>
        /// Esta rotina verifica na lista de eventos se há codigo de barras (barcode). Caso possua retorna True, e coloca o endereco do terminal ID e o codigo de barras em barcode
        /// </summary>
        /// <param name="ID"></param>
        /// <param name="BarCode"></param>
        /// <returns></returns>
        [DllImport("ecdSweda.dll", CallingConvention = CallingConvention.StdCall)]
        public static extern unsafe bool bReceiveBarcode(stAddress* ID, IntPtr BarCode);
        
        /// <summary>
        /// //Esta rotina envia a mensagem para o terminal ID indicando que o produto nao foi cadastrado
        /// </summary>
        /// <param name="ID"></param>
        /// <returns></returns>
        [DllImport("ecdSweda.dll", CallingConvention = CallingConvention.StdCall)] public static extern unsafe bool bSendProdNotFound(ref stAddress ID);
        
        /// <summary>
        /// // esta rotina envia a mensagem para o terminal ID indicando o nome (NameProd) e preco (PriceProd) do produto
        /// </summary>
        /// <param name="ID"></param>
        /// <param name="NameProd"></param>
        /// <param name="Price"></param>
        /// <returns></returns>
        [DllImport("ecdSweda.dll", CallingConvention = CallingConvention.StdCall)]
        public static extern unsafe bool bSendProdPriceTC50X(ref stAddress ID, string NameProd, string Price);
        
        /// <summary>
        /// // Esta rotina retorna TRUE, quando um Terminal se conecta no servidor
        /// </summary>
        /// <param name="ID"></param>
        /// <returns></returns>
        [DllImport("ecdSweda.dll", CallingConvention = CallingConvention.StdCall)]
        public static extern unsafe bool bConnect(stAddress* ID);
       
        /// <summary>
        /// // Esta rotina retorna TRUE, quando um TC se desconecta do servidor
        /// </summary>
        /// <param name="ID"></param>
        /// <returns></returns>
        [DllImport("ecdSweda.dll")] public static extern unsafe bool bDisconnect(stAddress *ID);

        /// <summary>
        /// Funcao para fechar um Terminal
        /// </summary>
        /// <param name="ID"></param>
        /// <returns></returns>
        [DllImport("ecdSweda.dll")]
        public static extern unsafe bool CloseTerminal(stAddress* ID);
        
        /// <summary>
        /// Converte a DWORD com IP em string (ascii)  separados por pontos.
        /// </summary>
        /// <param name="IP"></param>
        /// <param name="SIP"></param>
        /// <returns></returns>
        [DllImport("ecdSweda.dll", CallingConvention = CallingConvention.StdCall)] public static extern unsafe void Inet_NtoA(uint IP, IntPtr SIP);
        
        /// <summary>
        /// Converte a string (ascii) IP separados por pontos em DWORD com IP 
        /// </summary>
        /// <param name="SIP"></param>
        /// <returns></returns>
        [DllImport("ecdSweda.dll", CallingConvention = CallingConvention.StdCall)]
        public static extern unsafe UInt32 Inet_Addr(string sIP);//[MarshalAs(UnmanagedType.LPStr)] string SIP);
        
        /// <summary>
        /// Altera a configuração do Terminal 
        /// </summary>
        /// <param name="ip"></param>
        /// <param name="ip_cliente"></param>
        /// <param name="ip_server"></param>
        /// <param name="mascara"></param>
        /// <param name="linha1"></param>
        /// <param name="linha2"></param>
        /// <param name="linha3"></param>
        /// <param name="linha4"></param>
        /// <param name="tempo"></param>
        /// <returns></returns>
        [DllImport("ecdSweda.dll", CallingConvention = CallingConvention.StdCall)]
        public static extern unsafe bool SendConfiguration(string ip, string ip_cliente, string ip_server, string mascara, string linha1, string linha2, string linha3, string linha4, string tempo);
        
        /// <summary>
        /// captura a configuração do Terminal 
        /// </summary>
        /// <param name="ip"></param>
        /// <param name="ip_cliente"></param>
        /// <param name="ip_server"></param>
        /// <param name="mascara"></param>
        /// <param name="linha1"></param>
        /// <param name="linha2"></param>
        /// <param name="linha3"></param>
        /// <param name="linha4"></param>
        /// <param name="tempo"></param>
        /// <returns></returns>
        [DllImport("ecdSweda.dll", CallingConvention = CallingConvention.StdCall)]
        public static extern unsafe bool GetConfigurationNew(string ip, IntPtr ip_cliente, IntPtr ip_server, IntPtr mascara, IntPtr linha1, IntPtr linha2, IntPtr linha3, IntPtr linha4, IntPtr tempo, IntPtr gateway, IntPtr linha5, IntPtr linha6, IntPtr linha7, IntPtr linha8);

        /// <summary>
        /// Captura a configuracao do terminal, e retorna em uma unica string.
        /// </summary>
        /// <param name="ip"></param>
        /// <param name="ip_cliente"></param>
        /// <returns></returns>
        [DllImport("ecdSweda.dll")]
        public static extern unsafe bool GetConfiguration(string ip, IntPtr dados);
        #endregion

        stAddress ID = new stAddress();
        string IPTerminal;
        
        public Principal()
        {
            InitializeComponent();
            Iniciar();
        }

        private uint mensagem=0;

        private void Iniciar()
        {
            if (bInitialize(this.Handle))
            {
                vGetMsgWinReceiveDataTC(ref mensagem);
            }
        }

        unsafe private void Leitor()
        {
            stAddress IP = new stAddress();

            IntPtr ptrtexto = Marshal.AllocHGlobal(64);
            string stexto, barcode;
            UInt32 ipconfig = 0;

            if (bConnect(&IP))
            {
                Inet_NtoA(IP.Ip, ptrtexto);
                IPTerminal = Marshal.PtrToStringAnsi(ptrtexto);
                Marshal.FreeHGlobal(ptrtexto);

                ipconfig= Inet_Addr(IPTerminal);
                listBox1.Items.Add(DateTime.Now.ToString("HH:mm:ss") + "  -> IP: " + IPTerminal);
                listBox1.Items.Add("                -> IP (htonl): " + Convert.ToString(ipconfig));

                listBox3.Items.Add(IPTerminal);
                
            }
            else
            {
                if (bDisconnect(&IP))
                {
                    Inet_NtoA(IP.Ip, ptrtexto);
                    IPTerminal = Marshal.PtrToStringAnsi(ptrtexto);
                    Marshal.FreeHGlobal(ptrtexto);

                    ipconfig = Inet_Addr(IPTerminal);
                    listBox2.Items.Add(DateTime.Now.ToString("HH:mm:ss") + "  -> IP: " + IPTerminal);
                    listBox2.Items.Add("                -> IP (htonl): " + Convert.ToString(ipconfig));

                    listBox3.Items.Remove(IPTerminal);
                }

                if (bReceiveBarcode(&IP, ptrtexto))
                {
                    barcode = Marshal.PtrToStringAnsi(ptrtexto);
                    Marshal.FreeHGlobal(ptrtexto);

                    labelCodebarRead.Text = barcode;

                    Inet_NtoA(IP.Ip, ptrtexto);
                    stexto = Marshal.PtrToStringAnsi(ptrtexto);
                    Marshal.FreeHGlobal(ptrtexto);

                    labelCodebarIP.Text= stexto;
                    if ((textBoxDescProd.Text.Trim() == "") || (textBoxPrecProd.Text.Trim() == ""))
                        bSendProdNotFound(ref IP);
                    else
                        bSendProdPriceTC50X(ref IP, textBoxDescProd.Text, textBoxPrecProd.Text);
                                       
                }
            }
        }
       
        [System.Security.Permissions.PermissionSet(System.Security.Permissions.SecurityAction.Demand, Name = "FullTrust")]
        protected override void WndProc(ref Message m)
        {
            if (m.Msg == this.mensagem)       
                Leitor();
      
            base.WndProc(ref m);
        }


        private void Principal_FormClosing(object sender, FormClosingEventArgs e)
        {
            bTerminate();
        }

        private void buttonEnviar_Click(object sender, EventArgs e)
        {
            string terminal, servidor, netmask, exibicao, linha1, linha2, linha3, linha4, IpAtual;
            bool ret;

            terminal = textTerminal.Text.Trim();
            servidor = textServidor.Text.Trim();
            netmask = textNetmask.Text.Trim();
            exibicao = textExibicao.Text.Trim();
            linha1 = textLinha1.Text.Trim();
            linha2 = textLinha2.Text.Trim();
            linha3 = textLinha3.Text.Trim();
            linha4 = textLinha4.Text.Trim();
            IpAtual = textTerminalSelecionado.Text.Trim();

            labelGetConfigString.Text = "";
            labelGetConfigString2.Text = "";

            ret = SendConfiguration(IpAtual, terminal, servidor, netmask, linha1, linha2, linha3, linha4, exibicao);
            
                if (ret)
                    MessageBox.Show("Configuração enviada com sucesso para o Terminal de IP: "+ IpAtual + ".", "Sweda - ECD", MessageBoxButtons.OK,
    MessageBoxIcon.Information);
                else
                    MessageBox.Show("Erro ao enviar a Configuração para o Terminal de IP: " + IpAtual + ".", "Sweda - ECD", MessageBoxButtons.OK,
    MessageBoxIcon.Error);

        }

        private void textExibicao_KeyPress(object sender, KeyPressEventArgs e)
        {
            if (!char.IsNumber(e.KeyChar) && e.KeyChar != 0x08)
            {
                e.Handled = true;
            }

        }

        private void buttonCapturar_Click(object sender, EventArgs e)
        {   IntPtr terminal = Marshal.AllocHGlobal(20);
            IntPtr servidor = Marshal.AllocHGlobal(20);
            IntPtr netmask = Marshal.AllocHGlobal(20);
            IntPtr exibicao = Marshal.AllocHGlobal(2);
            IntPtr linha1 = Marshal.AllocHGlobal(40);
            IntPtr linha2 = Marshal.AllocHGlobal(40);
            IntPtr linha3 = Marshal.AllocHGlobal(40);
            IntPtr linha4 = Marshal.AllocHGlobal(40);
            IntPtr pNulo = System.IntPtr.Zero;

            IntPtr GetConfigString = Marshal.AllocHGlobal(256);
            bool ret;
            string IpAtual, configString;

            IpAtual = textTerminalSelecionado.Text.Trim();
            labelGetConfigString.Text = "";
            labelGetConfigString2.Text = "";


            ret = GetConfigurationNew(IpAtual, terminal, servidor, netmask, linha1, linha2, linha3, linha4, exibicao, pNulo, pNulo, pNulo, pNulo, pNulo);
            
            if (ret)
            {
                textTerminal.Text = Marshal.PtrToStringAnsi(terminal);
                textServidor.Text = Marshal.PtrToStringAnsi(servidor);
                textNetmask.Text = Marshal.PtrToStringAnsi(netmask);
                textExibicao.Text = Marshal.PtrToStringAnsi(exibicao);
                textLinha1.Text = Marshal.PtrToStringAnsi(linha1);
                textLinha2.Text = Marshal.PtrToStringAnsi(linha2);
                textLinha3.Text = Marshal.PtrToStringAnsi(linha3);
                textLinha4.Text = Marshal.PtrToStringAnsi(linha4);

                ret = GetConfiguration(IpAtual, GetConfigString);
                
                if (ret)
                {
                    configString = Marshal.PtrToStringAnsi(GetConfigString);
                    if(configString.Length > 50)
                    {   labelGetConfigString.Text= configString.Substring(0,50);
                        labelGetConfigString2.Text= configString.Substring(50);
                    }
                    else
                        labelGetConfigString.Text= configString;
                        
                }

                MessageBox.Show("Captura dos dados do Terminal de IP (" + IpAtual + ") realizada com sucesso.", "Sweda - ECD", MessageBoxButtons.OK,
     MessageBoxIcon.Information);
            }
            else
            {
                MessageBox.Show("Erro ao capturar os dados do Terminal de IP : " + IpAtual + ".", "Sweda - ECD", MessageBoxButtons.OK,
     MessageBoxIcon.Error);
                textTerminal.Text = "";
                textServidor.Text = "";
                textNetmask.Text = "";
                textExibicao.Text = "";
                textLinha1.Text = "";
                textLinha2.Text = "";
                textLinha3.Text = "";
                textLinha4.Text = "";
                
            }

            
            Marshal.FreeHGlobal(terminal);
            Marshal.FreeHGlobal(servidor);
            Marshal.FreeHGlobal(netmask);
            Marshal.FreeHGlobal(exibicao);
            Marshal.FreeHGlobal(linha1);
            Marshal.FreeHGlobal(linha2);
            Marshal.FreeHGlobal(linha3);
            Marshal.FreeHGlobal(linha4);
            Marshal.FreeHGlobal(GetConfigString);
            
        }

        private void buttonCloseTerminal_Click(object sender, EventArgs e)
        {
            stAddress IP = new stAddress();
            bool ret;

            IP.Ip = Inet_Addr(textTerminalSelecionado.Text.Trim());

            ret= CloseTerminal(&IP);

            if (ret)
                MessageBox.Show("O Terminal de IP (" + textTerminalSelecionado.Text.Trim() + ") foi desconectado com sucesso.", "Sweda - ECD", MessageBoxButtons.OK,
     MessageBoxIcon.Information);
            else
                MessageBox.Show("Erro, o Terminal de IP (" + textTerminalSelecionado.Text.Trim() + ") não está conectado ou não existe.", "Sweda - ECD", MessageBoxButtons.OK,
    MessageBoxIcon.Information);

        }

        private void listBox3_SelectedIndexChanged(object sender, EventArgs e)
        {
            textTerminalSelecionado.Text = listBox3.Text;
        }

       
                
       
    }
}