#include "ecdcontroller.h"

#include <QDebug>

const int msec = 1000; // 1 segundo

EcdController::EcdController(WId id, QObject *parent) : QObject(parent)
{
    if(ecdSweda.bInitialize((HWND)id)) {
        quint32 msg = 0;
        ecdSweda.vGetMsgWinReceiveDataTC(&msg);
    }

    connect(&timer, SIGNAL(timeout()), this, SLOT(process()));
}


EcdController::~EcdController() {
    timer.stop();

    ecdSweda.bTerminate();
}

void EcdController::start() {
    timer.start(msec);
}

void EcdController::stop() {
    timer.stop();
}


void EcdController::process() {
    int port = 0;
    QString ip;
    QString barcode;

    qDebug() << "verificando...";

    if(ecdSweda.bDisconnect(port, ip)) {
        qDebug() << "Ecd desconectado " << ip << " porta " << port;
        emit sgMessage("Ecd desconectado " + ip);
    }

    if(ecdSweda.bConnect(port, ip)) {
        qDebug() << "Novo ecd conectado " << ip << " porta " << port;
        emit sgMessage("Ecd conectado " + ip);
    }

    if(ecdSweda.bReceiveBarcode(port, ip, barcode)) {
        qDebug() << "Nova requisicao de codigo de barras " + barcode;
        emit sgMessage("Requisicao do codigo de barras " + barcode);
    }
}
